'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _loadJsonFile = require('load-json-file');

var _loadJsonFile2 = _interopRequireDefault(_loadJsonFile);

var _globby = require('globby');

var _globby2 = _interopRequireDefault(_globby);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

exports.default = function (directory) {
  var lernaJsonPath = _path2.default.join(directory, 'lerna.json');
  if (_fs2.default.existsSync(lernaJsonPath)) {
    var lernaJson = _loadJsonFile2.default.sync(lernaJsonPath);
    if (!lernaJson.useWorkspaces) {
      return findPackages(lernaJson.packages, directory);
    }
  }

  var pkgJsonPath = _path2.default.join(directory, 'package.json');
  if (_fs2.default.existsSync(pkgJsonPath)) {
    var pkgJson = _loadJsonFile2.default.sync(pkgJsonPath);
    if (pkgJson.workspaces) {
      return findPackages(pkgJson.workspaces, directory);
    }
  }

  throw new Error('unable to find monorepo packages');
};

var findPackages = function findPackages(packageSpecs, rootDirectory) {
  return packageSpecs.reduce(function (pkgDirs, pkgGlob) {
    return [].concat(_toConsumableArray(pkgDirs), _toConsumableArray(_globby2.default.sync(_path2.default.join(rootDirectory, pkgGlob), {
      nodir: false
    })));
  }, []).map(function (fsPath) {
    return { fsPath: fsPath, name: getPackageName(fsPath) };
  }).filter(function (_ref) {
    var name = _ref.name;
    return name;
  });
};

var getPackageName = function getPackageName(packagePath) {
  var pkgJsonPath = _path2.default.join(packagePath, 'package.json');
  if (_fs2.default.existsSync(pkgJsonPath)) {
    var pkgJson = _loadJsonFile2.default.sync(pkgJsonPath);
    return pkgJson.name;
  }
};